#!/usr/bin/perl -w

use strict;

use Getopt::Long;
use Net::SMTP;
use Config::Simple;


#my $FILE_TEST = "/proc/partitions";
#my @tab_disque;
my $index = 0;

my $pwd = "/usr/local/bin";

#
#open FILE_TEST, "/proc/partitions";
#
#while (<FILE_TEST>) {
#	chomp ($_);
#	my @pop = split / /, $_;
#	my $pop = $pop[@pop - 1];
#	
#	if (($pop) && (length ($pop) == 3)) {
#		$tab_disque[$index] = $pop;
#		$index = $index + 1;
#	}
#}


# Variable generale
my $subject = "";
my $corps = "";

# Recuperation de la ligne de commande
my $help = "";
my $test_mail = "";
my $test_config = "";

GetOptions("test_mail" => \$test_mail,
		"test_config" => \$test_config,
		"help"      => \$help) || printusage() ;
$help and printusage();


# Parse le fichier de configuration
my $config = new Config::Simple("$pwd/control_disk.conf") or die Config::Simple->error();

# Variable pour l envoi d email
my $smtp_host = $config->param("smtp_host") or error_fichier_configuration("smtp_host");

my $from_mail = $config->param("from_mail") or error_fichier_configuration("from_mail");
my $from_name = $config->param("from_name") or error_fichier_configuration("from_name");

my $dest_mail = $config->param("dest_mail") or error_fichier_configuration("dest_mail");
my $dest_name = $config->param("dest_name") or error_fichier_configuration("dest_name");

my $hostname = `/bin/hostname`;
chomp ($hostname);

if ($test_mail) {
	$subject = $hostname . ": Test d'envoi d'e-mail";
	$corps = "La machine " . $hostname . " vous envoie cet e-mail afin de tester son systme d'alerte par e-mail.";
	send_email($subject, $corps);
	exit 0;
}

my $nb_controleur = $config->param("nb_controleur");

#my $nb_disque_virtuel = @tab_disque;
#
#print "pas bon, disque : " . $nb_disque_virtuel . "\n";

for (my $i = 1; $i <= $nb_controleur; $i++) {

	my $disc_controleur = $config->param("disc_controleur" . $i);
#	my $model = $config->param("model" . $i);
#	my @help = `/usr/sbin/tw_cli help info`;
	
	
	foreach my $j (split / /, $disc_controleur) {
		my $retour = `/usr/sbin/tw_cli info c$i p$j smart 2> /dev/null`;
			
		if (!$retour) {
print "c$i p$j\n";
			$subject = "Urgent et important: " . $hostname . ": disque hors service";
			$corps = "Bonjour,\n\n";
			$corps = $corps . "le serveur " . $hostname . " vous signale que le disque " . $j . " du controleur numero " . $i;
			$corps = $corps . " est soit hors service, soit retir de son logement.\n\n";
			$corps = $corps . "Merci de faire le ncessaire le plus rapidement possible.\n\n";
			$corps = $corps . "Le service technique INTELLIQUE.\n\n";
			$corps = $corps . "tech\@intellique.com\n";
			$corps = $corps . "Tl 01 46 97 25 46\n";

			send_email($subject, $corps);

			exec `$pwd/alerte_sonore.pl &`;

		}
	}

}



exit 0;

# Sous programme

sub send_email {
	my ($subject, $mailbody)=@_;
	
	my $date = `/bin/date --rfc-2822`;
	chomp ($date);
	
	my $smtp = Net::SMTP -> new($smtp_host) or print "ERROR Mail: $!\n";

	$smtp->mail($from_mail);
	$smtp->to($dest_mail);
	$smtp->data();
	$smtp->datasend("From: $from_name <$from_mail>\n");
	$smtp->datasend("To: $dest_name <$dest_mail>\n");
	$smtp->datasend("Date: $date\n");
	$smtp->datasend("Subject: $subject\n\n");
	$smtp->datasend("\n$mailbody\n");
	$smtp->dataend();
	$smtp->quit;
}

sub error_fichier_configuration {
	my ($error_message)=@_;

	print "Probleme dans le fichier de configuration.\n";
	print "Le paramtre " . $error_message . " est soit manquant, soit vide.\n";
		
	exit 1;
}

sub printusage {
    print <<USAGE;

usage:
        control_disk.pl [-options ...]

where options include:
    -help			print out this message
    -test_mail			teste l envoi
    -test_config		teste le fichier de configuration

Home: http://www.intellique.com

USAGE
    exit 1;
}
